#!/usr/bin/env python3
"""
Roll for color. From the Perfect Run webserial.
https://docs.google.com/document/d/1_R5e8gJ2qpFFkNmaLuMnC_Of0PYoAUpGGoJ8lc8oER4/edit?pli=1&tab=t.0
"""
import random

import module


@module.commands("pr")
def perfectrun(bot, trigger):
	"""
	Rolls for powers from Perfect Run.
	"""
	roll = random.randint(1,100)

	if 1 <= roll <= 24:
		color = 'green'
	elif 25 <= roll <= 44:
		color = 'orange'
	elif 45 <= roll <= 63:
		color = 'red'
	elif 64 <= roll <= 80:
		color = 'blue'
	elif 81 <= roll <= 93:
		color = 'yellow'
	elif 94 <= roll <= 98:
		color = 'violet'
	elif 99 <= roll <= 100:
		color = 'white'

	tables = {
		'red': red,
		'orange': orange,
		'yellow': yellow,
		'green': green,
		'blue': blue,
		'violet': violet,
		'white': white
	}
	table = tables[color]
	power = random.choice(table)

	elixers = {
		'red': "\x0304Red - Energy",
		'orange': "\x0307Orange - Matter",
		'yellow': "\x0308Yellow - Concepts",
		'green': "\x0309Green - Life",
		'blue': "\x0311Blue - Information",
		'violet': "\x0306Violet - Spacetime",
		'white': "\x0300White - Meta-Powers"
	}
	elixer = elixers[color]

	bot.reply("Your Elixer: " + elixer)
	bot.reply("Your Power: " + power)
	if color == 'blue' and power.startswith('Genius'):
		bot.reply("Your Genius Expertease: " + random.choice(genius))
	
	

red = [
	"Living Sun: you can transform into a living sun, with all associated abilities (solar energy production, gravitational control…).",
	"Wavelength: you can transform into a living wavelength, allowing you to move at lightspeed and become invulnerable to physical attacks.",
	"Pyrokinesis: you can generate flames and manipulate them.",
	"Radio: you can manipulate sound.",
	"Telekinesis: you create force fields allowing you to lift or crush objects.",
	"Motion: you can manipulate motion, allowing you to either move at superspeed, or to throw any item you touch at supersonic speed.",
	"Vibration: you can cause intense vibrations with your hands, for example creating air blasts or blowing up buildings on touch.",
	"Energy Sword: you can create laser swords with your hand.",
	"Crimson Lightning: you can generate crimson lightning from your body and redirect it at will.",
	"Laser: you can generate lasers from your body, from the fingers to the eyes.",
	"Explosion: you can charge solid matter with destructive energy, causing it to violently explode soon afterward.",
	"Shock Absorption: you absorb kinetic energy and store it into your body, increasing its size and strength. You passively lose the accumulated energy. ",
	"Fallout: your body emits nuclear forces, turning you into a living nuclear holocaust.",
	"Kinetic Arms: you create tentacles of kinetic energy allowing you telekinetically manipulate things from afar, like additional arms.",
	"Lightshow: you can manipulate light, allowing you to create visual illusions, rays, or even dangerous flashes.",
	"Graviforce: you can manipulate gravity within a certain radius.",
	"Magnafield: you can control magnetism within a certain radius.",
	"Stillness: you can slow or outright negate motion around yourself, slowing objects, paralysing them, or de facto negating shocks.",
	"Black Hole: you can create miniature black holes capable of destroying entire cities.",
	"Redirect: you can redirect any form of energy around yourself, from kinetic strength to lightning.",
]

orange = [
	"Diamond Skin: you can turn your skin into superhard Carbon.",
	"Iron Giant: your body turns into metal; additionally, you can absorb any metal you touch into your biomass.",
	"White Mist: you create a cryogenic mist capable of turning anything into ice.",
	"Water Manipulation: you mentally control water in its natural state, the purer the better; you cannot control water within living bodies.",
	"Rust Fumes: your body transforms into metal-corroding gas, which grants you immunity to physical attacks. However, wind may blow you away.",
	"Glass Field: you can control glass and most silica within a certain radius.",
	"Acid Cloud: you can summon a cloud of toxic, acidic rain at will. You are immune to its negative effects.",
	"Intangibility: you can turn yourself and anything/anyone you touch intangible, allowing them to phase through matter.",
	"Ink: your body transforms into ink; you can change your shape and your color, granting you resistance to physical attacks and camouflage.",
	"Multi-Breath: you can transform your breath into various kinds of gas, like flammable gas, toxic breath etc...",
	"Tempest: you can manipulate air and winds, even alter the weather by altering atmospheric currents.",
	"Golem: you can create animated constructs from any kind of inorganic matter, from steel to dirt, that obey your every order.",
	"Dissolve: you can dissolve matter into raw molecules on touch.",
	"Gorgon Gaze: you can transform anything you see into stone, from people to water.",
	"Diceweight: you can increase or decrease the mass of anything within a certain radius.",
	"Transmute: you can transmute any inorganic matter into another, like lead to gold.",
	"Materialize: you can mentally materialize any inanimate object you can conceive, from chairs to buildings. You cannot create living beings.",
	"Stateless: you can transform the state of your body from liquid, gaseous, or solid.",
	"Copymatter: if you touch inorganic matter, you can temporarily have your body mimic its properties.",
	"Living Molecule: you have complete control over your body’s molecules, allowing you to reassemble them as you wish.",
]

yellow = [
	"Calamity Force: you can curse a single target with bad luck, causing increasingly dangerous calamities to befall your enemies.",
	"Lucky: you have phenomenal luck. Whatever happens, you will benefit from it.",
	"Undeath: you cannot die. Your ‘spirit’ inhabits your molecules, allowing you to survive even if reduced to bones or broken into countless parts.",
	"Ghostbuster: if you die, you transform into a powerful ghost bound to your earthly remains.",
	"Death Calling: you manipulate death, allowing you to sense someone’s age and cause death to catch up to them if certain conditions are met.",
	"Shadowmancer: you can manipulate your shadow; if it ‘hits’ something’s shadow, the victim’s body suffers the same damage.",
	"Necromancy: you animate corpses with necrotic power, allowing you to temporarily command them from afar and speak through them.",
	"Tulpa: you manifest an imaginary friend, that represents your subconscious thoughts.",
	"Cosplayer: you temporarily copy the attributes of a public persona or fictional character by dressing as them.",
	"Fictionland: you can physically enter a story or novel. This manifests in the creation of a closed illusory world mimicking the story’s content and repeating itself endlessly.",
	"Landowner: you fuse with a swath of land and gain conceptual control over it; this allows you to broadly see anything that happens there, and negate other conceptual powers within it.",
	"Love String: you create a bond between two people, forcing them to fall in love. The two will instinctively find one another no matter the distance, and probabilities will subtly change to allow that outcome.",
	"Cut: you can imbue a blade, from a kitchen knife to a sword, with the conceptual ability to cut anything.",
	"Reincarnation: your consciousness transcends your body; if you are killed, it transfers to a newborn of your species chosen at random. You keep your memories, and the power carries over from one host to the next.",
	"Karmic Form: you can transform people into a reflection of their inner self. For example, a saint will look like an angel, with a corrupt individual will turn into a bloated fiend. The victim does not gain any powers.",
	"Animate: you can animate inanimate objects like cars, swords, or even buildings, granting them ability to move by themselves and sentience.",
	"Sanctuary: you can mark one single area as a sanctuary. Anyone that you have not explicitly invited inside cannot cross the threshold, as an invisible force keeps them out.",
	"Geas: you can create an unbreakable agreement between two willing people, making them unable to break the wording of the agreement.",
	"Painful Choice: you can force someone to either choose Hell or Heaven; if they choose Heaven, they instantly die. If they choose Hell, they are wracked with pain for one hour. If the target doesn’t answer quickly, the result defaults to Heaven. You can only offer the choice once per person.",
	"Worldsoul: you passively warp reality around yourself so it reflects your inner self. For example, if you are depressive, gloom prospers, colors vanish, and people start wasting away. You do not control this effect.",
]

green = [
	"Panda Overdrive: you can transform into a mighty Panda.",
	"Dragonlord: you can transform into a powerful dragon beast.",
	"DNA Manipulation: you can alter the DNA of any living being you touch.",
	"Petalmancy: you can artificially grow and control plants.",
	"Mosquito: you permanently transform into a mosquito hybrid; your strength increases to superhuman level, the more blood you consume.",
	"Bloodstream: you can manipulate blood within a certain radius, including your own.",
	"Rat King: you can transform specific rats into ‘Genome Rats’. These animals have an enhanced metabolism and human intelligence, can command lesser rats, and serve as extensions of your neural system. If these Genome Rats reproduce with normal rats, the children are always Genome Rats.",
	"Bodyjacker: you can transform people into backup bodies, allowing you to reshape their flesh into a copy of your old body when you perish.",
	"Lifegiver: you can create small creatures, from plants to animals, from your shed blood.",
	"Succubus: you can manipulate pheromone, allowing you to seem irresistible to anyone; additionally, you can poison their body through direct contact by altering their hormones.",
	"Esthetic Surgery: you can reshape the appearance of people like one would clay.",
	"World Serpent: you can transform into a colossal serpent, capable of absorbing dead biomass on contact to regenerate itself.",
	"Peak: your body is always in top condition, granting you unlimited endurance, immunity to fatigue, toxins, sleep, etc…",
	"Feline: you can shapeshift into a werefeline, granting you extraordinary strength, agility, and enhanced senses.",
	"Reptilian: your body gains the properties of reptiles, including steel-hard scales, wall-crawling, camouflage and limited regeneration.",
	"Protean: you can transform into any animal of your choosing, so long as you recorded their DNA by touching them. You cannot copy other humans, and always default to your own when you try.",
	"Pandemic Bomb: you can create viruses, bacterias, and illnesses from your body; additionally, you are immune to all diseases.",
	"Rot: you can instantly rot organic matter on touch.",
	"Regenerator: your body regenerates from any damage, so long as a single cell remains. If your body parts are separated, they regenerate into copies of yourself.",
	"Ultimate Lifeform: you become the ultimate lifeform, your body instantly adapting to any environment or conditions (ex giving you scales to swim underwater, allowing you to breath in toxic air etc…). You do not control the changes.",
]

blue = [
	"Mind-control: you can control the mind of any human within ten meters of yourself.",
	"God’s Voice; any order you vocalize to someone becomes an irresistible compulsion, and the victim must immediately carry it out.",
	"Parallel Mind: you can observe multiple alternate universes through the eyes of your counterparts, allowing you to predict the future.",
	"Mindworm: you can permanently transform the mind of any person you touch into a copy of your own.",
	"Genius: you gain supernatural knowledge of an area of science or technology, such as water-based tech, weapons, human psychology… If you aren’t sure about your chosen specialty, you can check the Genius table below and roll for one.",
	"Truthsayer: if you ask someone a question, you compel them to answer truthfully.",
	"Nervejacker: you can physically connect to databases, including brains, allowing you to read and manipulate information.",
	"Intuimotion: you intuitively sense any movement within a certain radius around yourself, granting you supernatural aiming and reflexes.",
	"Insanity: you telepathically invade someone’s mind and drive them to madness through vivid hallucinations.",
	"Network: you create a telepathic network with someone you touch for a few hours, allowing you to communicate with them. Networked people intuitively work as a single unit.",
	"Incognito: you can force people to perceive you as someone else of your choosing, even through cameras.",
	"Technopathy: you mentally connect and control machines within a given radius.",
	"Beastmaster: you gain telepathic control over a random animal species within a large radius. This includes the ability to see through their senses.",
	"Psychometry: you can learn an object or person’s entire history by touching them.",
	"Stop: you stop the perception of time of any living being within a certain radius; to these people, time to have stopped.",
	"Enhanced Learning: you learn at a phenomenal rate, allowing you to master a language simply by reading a book in that tongue, quickly understand any technology, master new skills at an incredible pace...",
	"Thought Bomb: you create a viral idea (like ‘X is God’), that spreads from one person to another when they communicate.",
	"Infoform: you become a being of living information, allowing you to travel from one mind to another, or into databases.",
	"Amnesia: you can read and manipulate one person’s memories at will.",
	"Scry: you can mentally observe a location or person from afar, so long as you are aware of their existence.",
]

genius = [
	"Aquatic: technology focusing on the ocean, including submarines, oceanic life, and water-related tech.",
	"Weapons: technology that focuses on physically harming or killing someone else, such as lasers, military vehicles, or bombs.",
	"Neuromancer: you understand how brain tissues work, allowing you to create brain-machine interfaces, biomechanical computers, artificial memories or brains...",
	"Computer Code: you are a master of hacking, computer programming, and creating artificial intelligences.",
	"Mindbreaker: you have a perfect understanding of psychology, allowing you to instantly profile individuals and manipulate their psyche.",
	"Genetic Dystopia: you are a specialist of DNA alterations, from cloning to gene therapy.",
	"Transportation: you understand technology allowing mobility of any kind, from creating vehicles to portals and teleportation devices.",
	"Geology: you perfectly understand geology and tectonic activities, allowing you to create things like earthquake generators or stone detectors.",
	"Robot Army: you can make any kind of robot, from a friendly tiny assistant to colossal mechas.",
	"Optics: you understand optics and light, allowing you to create things like invisibility suits, holograms, or lasers.",
	"Atmospheric: you understand meteorology and anything related to planets’ atmospheres, allowing you to create weather-altering machines.",
	"Farmer: you are a specialist of all forms of agriculture, from gardening and horticulture to animal husbandry. This allows you to create new strains of plants and animals, enhance their productivity, or create powerful fertilizers.",
	"Corona Squad: you are a specialist of virology and anything related to plagues, from viruses to infections.",
	"Grafts: you can make any kind of prosthesis or biomechanical implants, from bionic eyes, grafting artificial organs, or even creating artificial tentacles linked to your spine.",
	"Linguist: you are a specialist of all forms of language and communications, allowing you to figure out any tongue, ‘discuss’ with aliens and animals, or create your own unbreakable codes.",
	"Medic: you are the world’s authority on medicine, allowing you to create machines capable of operating others, understand and solve almost any health issue, or even improve a body through specialized surgery.",
	"Chemist: you are a specialist of chemistry, allowing you to create new materials centuries ahead of their time, devastating chemical weapons, or any form of explosive.",
	"Drug Wizard: you can create any form of drug or psychotropic substances, including hallucinogens, addictive substances, or performance enhancers.",
	"City Planner: you are an expert at creating any kind of city. This makes you an expert urban planner, but also allows you to invent arcology designs, floating cities, or even self-sustaining colony spaceships.",
	"Terraformer: you understand how to change the very environment. You can create artificial biodomes, or design machines capable of transforming any environment into another (ex slowly transform Mars into Earth, or Yellowstone into an alien landscape).",
]

violet = [
	"Temporal Bilocation: you can create a save point by dividing yourself across time and space.",
	"Summoner: you can summon alien monsters from a distant universe, though you do not control them.",
	"Time Leap: you create a time anomaly allowing you to leap into the future; to everyone except you, it seems time skipped forward (“I erased time and leapt past it!”).",
	"Teleportation: you can teleport at any place you can see.",
	"Space Rift: you create a rift in space capable of cutting anything, down to the molecular level.",
	"Bottomless: you hold a pocket dimension inside your stomach, allowing you to stock and pull out anything within.",
	"Armory: you can mark small items and store them inside a pocket dimension; you can then summon them at will within ten meters of yourself.",
	"Reload: your body instantly reloads to a previous state anytime you are killed or harmed, though your mind carries over.",
	"Portal: you can create spatial portals linking two locations you are familiar with.",
	"Clockstop: you can freeze an object or person in time on touch, as long as you wish.",
	"Compress: you can compress space at a specific point, crushing anything within; including people, if you wish.",
	"Switch: you can switch places with anything in sight.",
	"Pathfinder: you gain an intuitive understanding of space, allowing you to always find your way to a destination.",
	"Future Call: you can summon a ‘future’ version of yourself from 24 hours in the future. The double has awareness of the future as if you hadn’t used your power, and disappears after 24 hours.",
	"Bullet Time: you desynch your timestream from the rest of the universe, making it seem as if time slows down for everything but you.",
	"Begone: you can teleport someone or something into the future (never backward). You decide how far, from a few seconds, to eons.",
	"Social Distancing: you can lengthen or shorten space in an area, causing hallways to seemingly stretch forever, or shortening distances.",
	"Loop: you can trap an area in a closed-time loop, where time and events constantly repeat themselves. The rest of the world is fine, and cannot interact with the time bubble.",
	"Dimension Leap: you can teleport to alternate realities or universes.",
	"Meteor: you teleport meteors from the depth of space at a specific location; you can choose the size from car-destroying stones to world-enders.",
]

white = [
	"Cancel: you negate other Genomes’ powers within a certain radius of yourself.",
	"Accel: you supercharge the powers of anyone within ten meters.",
	"All for One: so long as they are within 10 meters of yourself, you temporarily prevent any Genome from using their powers and you can use them instead, though at reduced strength",
	"Mongrel: you can hold an unlimited number of powers within your body instead of just two max, but you are NOT immune to Psycho degeneration.",
	"RNG: every 24 hours, you get a new power chosen at random. Once 24 hours have passed, you switch that power for another.",
	"Sphere: you create colored spheres each with a different effect, depending on the color (ex heat explosion for Red, body paralysis for Green etc…).",
	"Mimic: if you touch a Genome, you copy their power; you can only use one power at once, and the ability resets each time you touch someone else.",
	"Empower: you can temporarily imbue a normal person with a weak power for one hour, after which it dissipates. You do not choose the power, but you select the color.",
	"One for All: you can permanently transfer your power to someone else. If that person already has a power, this ability fuses with it, allowing the recipient to transfer the ability next.",
	"Identify: you identify Genomes by a colored aura around them. The more you look at it, the better you understand their abilities.",
	"Tune: you can permanently ‘tune’ someone else’s power, for example increasing its strength at the cost of the user’s control.",
	"Pulse: you can create a pulse around yourself that signals your presence to every Genome within a vast radius. Non-superpowered beings do not sense it.",
	"Redo: you can change someone’s power to another, within their color’s spectrum (change one Green power to another). However, the body itself does not change, which may cause health complications or even death if they cannot adapt to their new ability.",
	"Power Killer: you permanently strip someone of their powers on touch.",
	"Immune: you cannot be affected by other powers, though you do not negate their activation (for example, a Red Genome’s flames cannot affect you, but you do not prevent them from creating them).",
	"Duplicate: you can temporarily make a given Genome ‘share’ his power with other, unpowered individuals, but everyone only has a fraction of its full potential.",
	"Power Outage: you cause someone to lose control over their power, forcing it into overdrive.",
	"Reflect: you redirect any superpowers aimed at you back to the sender.",
	"No Brakes: you selectively remove the safeguards prevent one’s power from harming themselves. For example, pyrokinetics are no longer immune to their own flames.",
	"Select: you can choose one power you wish, and the chosen power permanently replaces “Select.” The power may misunderstand you wish and grant you the closest interpretation it can have (ex ‘I want to be immortal’ can lead to absolute regeneration or undeath).",
]
